class Game.PongCharacterSelect extends MovieClip
{
   var player_mc;
   var opponent_mc;
   var side_mc;
   var start_btn;
   var dispatchEvent;
   var __player = 0;
   var __side = 0;
   var __opponent = 0;
   var playerTitle = "PICK A FRIEND";
   var opponentTitle = "PICK A FOE";
   static var __inited = false;
   function PongCharacterSelect()
   {
      super();
      if(!Game.PongCharacterSelect.__inited)
      {
         this.init();
      }
      this.player_mc.title_txt.text = this.playerTitle;
      this.opponent_mc.title_txt.text = this.opponentTitle;
   }
   function set player(newPlayer)
   {
      this.player_mc.selectedItem.selected = false;
      this.player_mc.selectedItem = this.player_mc["choice" + newPlayer];
      this.player_mc.selectedItem.selected = true;
      this.__player = newPlayer;
   }
   function get player()
   {
      return this.__player;
   }
   function set side(newSide)
   {
      this.side_mc.selectedItem.selected = false;
      this.side_mc.selectedItem = this.side_mc["choice" + newSide];
      this.side_mc.selectedItem.selected = true;
      this.__side = newSide;
   }
   function get side()
   {
      return this.__side;
   }
   function set opponent(newOpponent)
   {
      this.opponent_mc.selectedItem.selected = false;
      this.opponent_mc.selectedItem = this.opponent_mc["choice" + newOpponent];
      this.opponent_mc.selectedItem.selected = true;
      this.__opponent = newOpponent;
   }
   function get opponent()
   {
      return this.__opponent;
   }
   function click(eventObj)
   {
      var _loc2_ = eventObj.value;
      var _loc3_ = eventObj.group;
      if(_loc3_ == "player")
      {
         this.playerTitle = Game.PongLevels.FRIENDS_NAMES[_loc2_].toUpperCase();
         this.player_mc.title_txt.text = this.playerTitle;
         this.player = _loc2_;
      }
      else if(_loc3_ == "side")
      {
         this.side = _loc2_;
      }
      else if(_loc3_ == "opponent")
      {
         this.opponentTitle = Game.PongLevels.FOES_NAMES[_loc2_].toUpperCase();
         this.opponent_mc.title_txt.text = this.opponentTitle;
         this.opponent = _loc2_;
      }
   }
   function rollOver(eventObj)
   {
      var _loc2_ = eventObj.value;
      var _loc3_ = eventObj.group;
      if(_loc3_ == "player")
      {
         this.player_mc.title_txt.text = Game.PongLevels.FRIENDS_NAMES[_loc2_].toUpperCase();
      }
      else if(_loc3_ == "opponent")
      {
         this.opponent_mc.title_txt.text = Game.PongLevels.FOES_NAMES[_loc2_].toUpperCase();
      }
   }
   function rollOut(eventObj)
   {
      var _loc3_ = eventObj.value;
      var _loc2_ = eventObj.group;
      if(_loc2_ == "player")
      {
         this.player_mc.title_txt.text = this.playerTitle;
      }
      else if(_loc2_ == "opponent")
      {
         this.opponent_mc.title_txt.text = this.opponentTitle;
      }
   }
   function init()
   {
      mx.events.EventDispatcher.initialize(Game.PongCharacterSelect.prototype);
      Game.PongCharacterSelect.__inited = true;
   }
   function initUI()
   {
      this.initSelectorGroup(this.player_mc,"player",this.__player);
      this.initSelectorGroup(this.side_mc,"side",this.__side);
      this.initSelectorGroup(this.opponent_mc,"opponent",this.__opponent);
      this.player_mc.title_txt.text = this.playerTitle;
      this.opponent_mc.title_txt.text = this.opponentTitle;
   }
   function initSelectorGroup(timeline, name, selectedIndex)
   {
      var _loc3_ = 0;
      var _loc2_ = undefined;
      while(timeline["choice" + _loc3_])
      {
         _loc2_ = timeline["choice" + _loc3_];
         _loc2_.group = name;
         _loc2_.value = _loc3_;
         _loc2_.addEventListener("click",this);
         _loc2_.addEventListener("rollOver",this);
         _loc2_.addEventListener("rollOut",this);
         if(_loc3_ == selectedIndex)
         {
            _loc2_.selected = true;
            timeline.selectedItem = _loc2_;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function initStartButton()
   {
      var controller = this;
      this.start_btn.onRelease = function()
      {
         controller.startGame();
      };
      this.initUI();
   }
   function startGame()
   {
      this.dispatchEvent({type:"onCharacterSelect",player:this.__player,side:this.__side,opponent:this.__opponent});
   }
}
