class Game.PongLevels
{
   static var e;
   static var FRAME_TIME = 0.06666666666666667;
   static var D = 1;
   static var S = 16;
   static var FRIENDS = [0,1,2,3,4];
   static var FOES = [5,6,7];
   static var FRIENDS_NAMES = ["Kim","Ron","Rufus","Bonnie","Monique"];
   static var FOES_NAMES = ["Drakken","Shego","DNAmy"];
   static var GOAL_SMALL = 1;
   static var GOAL_WIDE = 6;
   static var PADDLE_SMALL = 7;
   static var PADDLE_WIDE = 2;
   static var PADDLE_STICKY = 9;
   static var MISSILE = 4;
   static var FREEZE_YOU = 5;
   static var FREEZE_OPPONENT = 0;
   static var BALL_FAST = 8;
   static var BALL_SLOW = 3;
   static var BONUS_POINTS = 10;
   static var BONUSES = [Game.PongLevels.FREEZE_OPPONENT,Game.PongLevels.GOAL_SMALL,Game.PongLevels.PADDLE_WIDE,Game.PongLevels.MISSILE,Game.PongLevels.PADDLE_STICKY,Game.PongLevels.BALL_SLOW];
   static var PENALTIES = [Game.PongLevels.FREEZE_YOU,Game.PongLevels.GOAL_WIDE,Game.PongLevels.PADDLE_SMALL,Game.PongLevels.BALL_FAST];
   static var ITEM_DESC = ["freeze_opponent","goal_small","paddle_wide","ball_fast","missile","freeze_you","goal_wide","paddle_small","ball_slow","paddle_sticky"];
   static var DEFAULT_ITEM_TIME = 20;
   static var FREEZE_ITEM_TIME = 5;
   static var DEFAULT_BLINK_TIME = 4;
   static var FREEZE_BLINK_TIME = 2;
   static var DEFAULT_SPEED = 300;
   static var LEVEL_SPEED_INCREMENT = 2;
   static var MAX_SPEED = 500;
   static var MAX_SPEED_INCREASE = 100;
   static var DEFAULT_ANGLE = 290;
   static var MIN_BALL_ANGLE = 25;
   static var PADDLE_SPEED = 350;
   static var DEFAULT_COMPUTER_HANDICAP = 250;
   static var LEVEL_HANDICAP_DECREASE = 2;
   static var MIN_HANDICAP = 150;
   static var BALL_SPEED_OFFSET = 75;
   static var BALL_MISSILE_FACTOR = 1.9;
   static var DEFAULT_ITEMS = [Game.PongLevels.MISSILE,Game.PongLevels.MISSILE,Game.PongLevels.PADDLE_STICKY,Game.PongLevels.PADDLE_STICKY,Game.PongLevels.FREEZE_YOU,Game.PongLevels.FREEZE_OPPONENT,Game.PongLevels.BALL_FAST,Game.PongLevels.BALL_SLOW,Game.PongLevels.GOAL_SMALL,Game.PongLevels.GOAL_WIDE,Game.PongLevels.PADDLE_WIDE,Game.PongLevels.PADDLE_SMALL,Game.PongLevels.BONUS_POINTS,Game.PongLevels.BONUS_POINTS,Game.PongLevels.BONUS_POINTS,Game.PongLevels.BONUS_POINTS,Game.PongLevels.BONUS_POINTS];
   static var DEFAULT_RECURRENCE = 7;
   static var DEFAULT_BRICK_POINT_VALUE = 25;
   static var DEFAULT_BONUS_POINTS_VALUES = [200,250];
   static var DEFAULT_GOOD_ITEM_VALUE = 100;
   static var DEFAULT_GOAL_VALUE = 500;
   static var DEFAULT_CLEAR_ALL_VALUE = 1000;
   static var levels = [];
   static var __inited = false;
   function PongLevels()
   {
      if(!Game.PongLevels.__inited)
      {
         Game.PongLevels.init();
      }
   }
   static function getLevels()
   {
      if(!Game.PongLevels.__inited)
      {
         Game.PongLevels.init();
      }
      return Game.PongLevels.levels;
   }
   static function addLevel(level)
   {
      if(level.speed == undefined)
      {
         level.speed = Game.PongLevels.DEFAULT_SPEED;
      }
      if(level.angle == undefined)
      {
         level.angle = Game.PongLevels.DEFAULT_ANGLE;
      }
      if(level.brickPointValue == undefined)
      {
         level.brickPointValue = Game.PongLevels.DEFAULT_BRICK_POINT_VALUE;
      }
      if(level.items == undefined)
      {
         level.items = Game.PongLevels.DEFAULT_ITEMS;
      }
      if(level.recurrence == undefined)
      {
         level.recurrence = Game.PongLevels.DEFAULT_RECURRENCE;
      }
      Game.PongLevels.levels.push(level);
   }
   static function isGoodItem(itemID)
   {
      var _loc1_ = Game.PongLevels.PENALTIES.length;
      while((_loc1_ = _loc1_ - 1) > -1)
      {
         if(Game.PongLevels.PENALTIES[_loc1_] == itemID)
         {
            return false;
         }
      }
      return true;
   }
   static function init()
   {
      Game.PongLevels01To05.init();
      Game.PongLevels06To10.init();
      Game.PongLevels.__inited = true;
   }
}
